Suggested Procedural Rules For Conference Meetings
Version 1.0
Steve Schmidt (Mobydick@TMI-2)   1-18-93

Section A. Preparation of the Agenda
Section B. Powers of the Moderator
Section C. Speaking Privileges
Section D. Resolutions and Voting


Section 1. Preparation of the Agenda

A1. The conference agenda shall be set prior to the meeting by the 
conference conveners.

A2. Before discussion is opened on the first agenda item, the moderator 
shall ask participants for motions for additions to the agenda. If 
suggestions are made, the moderator decides whether to accept them, and if 
accepted, where on the agenda to place them. Motions to add to the agenda 
are not in order after the first agenda item is opened.

A3. At the opening of discussion on each agenda item, the moderator may set 
a minimum number of speakers who must speak before a motion to close the 
agenda item. The moderator may also set an initial speaking list at the 
opening of discussions. (See rule C1.) Such actions must be taken before the 
first speaker speaks and are out of order thereafter. Such actions are not 
subject to appeal.

A4. At any time after the minimum number of speakers have spoken, 
participants may motion to close discussion on the current agenda item. 
Such motions require a majority vote to pass. In addition, the moderator 
may unilaterally close discussion on an agenda item. If an agenda item is 
closed, discussion proceeds to the next agenda item. The conference ends 
when all agenda items have been closed.

Section B. Powers of the Moderator

B1. The moderator shall have the right to prevent entry into the meeting 
room. Exit shall be permitted at all times. The moderator shall have the 
power to permit single individuals to enter the room if locked. The 
moderator shall have the right to eject any participant from the meeting 
room. All decisions taken under rule B1 are unappealable.

B2. If the proceedings are being echoed to an observation room, the 
moderator shall have the power to suspend this echoing if the privacy of the 
participants requires it. Such suspensions shall be kept as short as possible. 
Decisions to suspend or resuming echoing are unappealable.

B3. The moderator shall have the right to keep a log of the proceedings of 
the conference and of the MUD names of the participants. The moderator may 
suspend logging and resume it at his discretion. Decisions to suspend or 
resume logging are unappealable.

B4. The moderator shall have the right to silence any participant and prevent 
that person from speaking either as a speaker or during general discussion. 
Silenced individuals may be granted comments, if the moderator desires.

B5. The moderator shall have the right to rule any motion frivolous and out 
of order. This decision is unappealable.

B6. Any decision of the moderator may be appealed by any participant, 
except those marked as unappealable in the rules. If a moderator's decision 
is appealed, the proceedings are immediately stopped and a vote is taken on 
the appeal. If the appeal is approved by a 3/4 majority of participants, the 
decision of the moderator is reversed.

B7. The moderator may wish to call for a show of hands before making 
procedural decisions. However, he is not bound by the results of such votes,
unless an appeal is made.

B8. The moderator shall not make comments related to the substance of 
discussion. His role is to moderate the discussion, not to take part in it.

Section C. Speaking Privileges.

C1.  The moderator shall keep a list of who will speak and in what order 
during the discussion. Any participant may ask to be placed on the end of the 
speaker's list. The moderator may refuse such requests. The speaker's list 
shall be accessible to all participants at all times. Any participant on the 
list may ask to be removed.

C2. The moderator shall have the right to limit the time permitted to any 
speaker at any time.

C3. When a speaker has the floor, only the speaker and the moderator shall 
be permitted to speak. The moderator may grant the right to make single 
comments to any participant at his discretion. Anyone who has not been 
silenced under rule B4 may speak at any time when the floor is open for 
general discussion.

C4. A speaker who is speaking under a time limit may yield his remaining 
time to any participant. Speakers not speaking under a time limit may not 
yield to other participants.

C5. Speakers may yield to questions from the floor. Questioners are selected 
by the moderator, and only the current questioner, the speaker, and the 
moderator may speak at this time. Only questions related to the content of 
the proceeding speech are in order. The moderator shall decide whether any 
question is unrelated.

C6. In between speakers, any participant may move that the speaker's list be 
suspended and the floor be opened for general discussion for a specified 
period of time. The moderator may refuse to grant such motions, or to 
shorten the time proposed. When the suspension ends, the speaker's list 
resumes, in the same form it was in when the motion to suspend was made, 
except for additions to the end, or removals by the moderator, under rule C1.

C7. The moderator shall not place himself on the speakers list.

Section D. Resolutions and Voting.

D1. At any time between speakers or during open discussion, any participant 
may introduce a resolution for the approval of the conference. Such 
resolutions must be related to the agenda item under discussion. All 
resolutions are subject to the approval of the moderator and the moderator
shall have the power to refuse to accept them.

D2. Any participant may move to amend a pending resolution. Amendments 
are also subject to the approval of the moderator.  An amendment is either 
friendly or hostile; the sponsor of the resolution declares which kind the 
amendment is when it is proposed. Friendly amendments are automatically 
accepted. Hostile amendments remain pending until discussion of the agenda 
item closes. Amendments to amendments are not permitted.

D3. Resolutions and amendments may be withdrawn by their sponsors at any 
time prior to the close of discussion on the agenda item. If a resolution is 
withdrawn, all pending amendments to it are automatically withdrawn.

D4. When discussion of an agenda item is closed, voting takes place. The 
resolutions are ordered by time of submission, first one proposed being 
voted on first. First, all pending amendments to the first resolution are 
voted on, also in order of submission. Then the first resolution is voted on. 
Voting proceeds on all resolutions, amendments first and then on the 
resolution, until all pending resolutions have been voted on.

D5. Any person in the conference room at the time the discussion is closed 
shall have the right to vote. The moderator may grant the right to vote to 
any other person he deems worthy of it.

D6. Resolutions require a simple majority to pass. Amendments require a 
2/3 majority to pass.

